/*
 * Constants.h
 *
 *  Created on: May 23, 2013
 *  Author: Omer Gilad
 */

#ifndef CONSTANTS_H_
#define CONSTANTS_H_


#undef ANDROID_PORT_DUMP_SCREEN
#undef ANDROID_PORT_DUMP_CURSOR

#include "GameInfo.h"

// General constants

#if (CURRENT_GAME_TYPE == GAME_TYPE_T7G || CURRENT_GAME_TYPE == GAME_TYPE_IHNM)
	#define SUPPORT_SOFTWARE_SCALER false
#else
	#define SUPPORT_SOFTWARE_SCALER true
#endif

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER_MAX_DISTANCE 40
#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER_UPPER_AREA 120
#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER_OFFSET 60

#define LOW_RES_SCREEN_W 1400

#define SHADER_SCALING_MAX_RESOLUTION_W 1280
#define SHADER_SCALING_MAX_RESOLUTION_H 800

#ifdef RELEASE_TYPE_DEBUG

	#define SHADER_SCALING_ULTRA_MAX_RESOLUTION_W 7680
	#define SHADER_SCALING_ULTRA_MAX_RESOLUTION_H 4800

#else

	#define SHADER_SCALING_ULTRA_MAX_RESOLUTION_W 1920
	#define SHADER_SCALING_ULTRA_MAX_RESOLUTION_H 1200

#endif

#define GL_TEXTURE_STATIC 0
#define GL_TEXTURE_DYNAMIC 1
#define GL_TEXTURE_DYNAMIC2 2


#define SKIP_X 0
#define SKIP_Y 0
#define SKIP_W 0.09

#define REVEAL_ITEMS_X 0.91
#define REVEAL_ITEMS_Y 0
#define REVEAL_ITEMS_W 0.09

#define REPLAY_X 0
#define MAP_X 0.91
#define LOWER_BUTTON_W 0.09

#define CONTROL_MODE_X 0
#define CONTROL_MODE_Y 0
#define CONTROL_MODE_W 0.09

#define MENU_X 0
#define MENU_Y 0
#define MENU_W 0.095

#define FRAME_W 0.1

#define BIG_ACTION_ICON_X 0.425
#define BIG_ACTION_ICON_Y 0.3
#define BIG_ACTION_ICON_W 0.15

#define SMALL_ACTION_ICON_W 0.08
#define SMALL_ACTION_ICON_PADDING 14

#define IHNM_COVER_DISK_X 0.96
#define IHNM_COVER_DISK_Y 0.632
#define IHNM_COVER_DISK_W 0.039
#define IHNM_COVER_DISK_H 0.052

#ifndef WIN32
	#define CURSOR_EXTRA_WIDTH_FACTOR_TOUCH_MODE 1.25
#else
	#define CURSOR_EXTRA_WIDTH_FACTOR_TOUCH_MODE 0.725
#endif

#define TOUCH_INDICATOR_INITIAL_FADE_DURATION 100

#define TOUCH_INDICATOR_LONG_CLICK_SCALE_FACTOR 1.3

#define HOTSPOT_MIN_DIMENSION_FOR_RECT_DRAWING 50

#define MIN_INVISIBLEMOUSEMOTION_DELAY 200

#define MUSIC_ENHANCED_BY_X 0.1
#define MUSIC_ENHANCED_BY_Y 0.7
#define MUSIC_ENHANCED_BY_W 0.8
#define MUSIC_ENHANCED_BY_BEGIN_TIME 3000
#define MUSIC_ENHANCED_BY_END_TIME 8000

// This is the amount of pixels that pad the actual copy area (so that it'll be inside the magnifier image but not on its edges)
#define MAGNIFIER_COPY_RECT_PADDING_PIXELS 1


#define CHAT_MODE_CHECK_Y 199
#define BOTTOM_TOOLBAR_CHECK_Y 199



// The amount of movement pixels to ignore when checking for long touch holding
#define WALK_ACTION_TOUCH_SENSITIVITY_PIXELS 5

#define BIG_ACTION_ICON_FADEIN_DURATION 100
#define BIG_ACTION_ICON_FADEOUT_DURATION 600
#define BIG_ACTION_ICON_FADE_MAX_ALPHA 0.8


#define HOTSPOT_SWITCH_FADEOUT_DURATION 150
#define HOTSPOT_LEAVE_FADEOUT_DURATION 1250

#define HOTSPOT_RECT_END_ALPHA 0.7


#define ACTION_BLINK_FADE_DURATION 125
#define ACTION_BLINK_REPEAT_COUNT 3
#define ACTION_ENTER_FADEIN_DURATION 500
#define ACTION_LEAVE_FADEOUT_DURATION 350

#define HOTSPOT_BLINK_FADE_DURATION 125
#define HOTSPOT_BLINK_REPEAT_COUNT 3


#define WALK_ICON_SINGLE_TAP_FADEIN_DURATION 50
#define WALK_ICON_SINGLE_TAP_FADEOUT_DURATION 450
#define WALK_ICON_SINGLE_TAP_MAX_ALPHA 1.0

#define REVEAL_ITEMS_FADEIN_DURATION 100
#define REVEAL_ITEMS_STAY_DURATION 2000
#define REVEAL_ITEMS_FADEOUT_DURATION 500

#define AUTOLOAD_SAFETY_TIME_INTERVAL 1000

#define SHADER_TYPE_HQ_VERTEX 0
#define SHADER_TYPE_HQ_FRAGMENT 1
#define SHADER_TYPE_LQ_VERTEX 2
#define SHADER_TYPE_LQ_FRAGMENT 3
#define SHADER_TYPE_RECT_HIGHLIGHTING_VERTEX 4
#define SHADER_TYPE_RECT_HIGHLIGHTING_FRAGMENT 5

#define AUTOSAVE_SLOT 1
#define AUTOSAVE_SLOT_NAME "autosave"


#define LOW_QUALITY_SHADER_SCALING_FACTOR 3

// Interval between clicks to prevent Simon from going idle
#define IDLE_PREVENTION_CLICK_INTERVAL 5000
// Coordinates for idle prevention click
#define IDLE_PREVENTION_CLICK_X 0
#define IDLE_PREVENTION_CLICK_Y 140

#define SIMON1_SAVE_TIMEOUT 5000
#define SIMON2_SAVE_TEST_TIME 2000
#define SIMON2_LOAD_DELAY_AFTER_INTRO 2000

#define MAP_SCROLL_AREA_W 35

#if defined(IPHONE)
	#define DISTANCE_THRESHOLD 50
#elif defined(WIN32)
	#define DISTANCE_THRESHOLD 25
#endif

#define MAX_HOTSPOTS 100

#define WALK_ASSIST_BORDER_SIZE_X 25
#define WALK_ASSIST_BORDER_SIZE_Y 5

#define ENHANCED_MUSIC_VOLUME 80

#define ICON_ALPHA_WHEN_REVEALING_ITEMS 0.0
#define ICON_ALPHA_WHEN_LONG_TEXT 0.5



// Simon 2 verb "selected" indicator
#define SIMON2_VERB_INDICATOR_W 0.098
#define SIMON2_VERB_INDICATOR_H 0.122

#define SIMON2_VERB_INDICATOR_COL1_X 0.015
#define SIMON2_VERB_INDICATOR_COL2_X 0.121
#define SIMON2_VERB_INDICATOR_COL3_X 0.781
#define SIMON2_VERB_INDICATOR_COL4_X 0.887
#define SIMON2_VERB_INDICATOR_ROW1_Y 0.731
#define SIMON2_VERB_INDICATOR_ROW2_Y 0.864

#define SIMON2_BOTTOM_PANEL_X 0.0
#define SIMON2_BOTTOM_PANEL_Y 0.72
#define SIMON2_BOTTOM_PANEL_W 1.0
#define SIMON2_BOTTOM_PANEL_H 0.28

// FOTAQ action "selected" indicator
#define FOTAQ_SELECTION_OVERLAY_W 0.0625
#define FOTAQ_SELECTION_OVERLAY_H 0.2

#define FOTAQ_SELECTION_OVERLAY_Y 0.8
#define FOTAQ_SELECTION_OVERLAY_X_1 0.0
#define FOTAQ_SELECTION_OVERLAY_X_2 FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_3 2 * FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_4 3 * FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_5 4 * FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_6 5 * FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_7 6 * FOTAQ_SELECTION_OVERLAY_W
#define FOTAQ_SELECTION_OVERLAY_X_8 7 * FOTAQ_SELECTION_OVERLAY_W


#define DEVELOPER_LOGO_BEFORE_GAME_DELAY 3000


#define T7G_OPEN_HOUSE_SAVE_SLOT 9
#define T7G_OPEN_HOUSE_SAVE_FILE "t7g.009"


//
// Constants differing between games
//

// ******** IHNM ********
#if CURRENT_GAME_TYPE == GAME_TYPE_IHNM

#define MAINTAIN_ASPECT_RATIO

#define ORG_ASPECT_RATIO 1.33

#define MIN_ASPECT_RATIO 1.33
#define MAX_ASPECT_RATIO 1.78

#define GAME_SCREEN_WIDTH 640
#define GAME_SCREEN_HEIGHT 480
#define GAME_SCREEN_HEIGHT_ORIGINAL 480

#define ACTION_ALPHA 1.0

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 350

#define MIN_CLICK_DELAY_AFTER_SKIP 750

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 7
#define RENDER_MEASURE_THRESHOLD 100
#define RENDER_MEASURE_MAX_TEST_TIME 3000

// Black text panel
#define BLACK_PANEL_START_Y 328
#define BLACK_PANEL_END_Y 328
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)

#define TOUCH_INDICATOR_W 0.035
#define TOUCH_INDICATOR_BACK_W 0.13

#define CLASSIC_CURSOR_W 0.03

#define TOUCH_INDICATOR_MIN_SCALE_W 0.04
#define TOUCH_INDICATOR_MAX_SCALE_W 0.05
#define TOUCH_INDICATOR_SCALE_DURATION 750

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 0


// Inventory panel
#define INVENTORY_SCROLL_ARROW_START_X 301
#define INVENTORY_SCROLL_ARROW_END_X 315
#define INVENTORY_FLING_MIN_X 170
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_FLING_MAX_X 320
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_UP_ARROW_X 315
#define INVENTORY_UP_ARROW_Y 160
#define INVENTORY_DOWN_ARROW_X 315
#define INVENTORY_DOWN_ARROW_Y 190



// Chat assitance
#define ARROW_W 0.1
#define ARROW_H 0.14
#define UP_ARROW_X (1 - ARROW_W - 0.01)
#define UP_ARROW_Y 0.39
#define DOWN_ARROW_X (1 - ARROW_W - 0.01)
#define DOWN_ARROW_Y (UP_ARROW_Y + ARROW_H + 0.01)
#define CHAT_BUTTON_W (ARROW_W * 1.6)
#define CHAT_BUTTON_H (ARROW_H * 2 + 0.01)
#define CHAT_BUTTON_X (UP_ARROW_X - CHAT_BUTTON_W - 0.01)
#define CHAT_BUTTON_Y UP_ARROW_Y
#define CHAT_HIT_AREAS_START_Y 136


// Postcard
#define POSTCARD_WINDOW_CHECK_Y 105
#define POSTCARD_LOAD_START_X 62
#define POSTCARD_LOAD_START_Y 40
#define POSTCARD_LOAD_END_X 156
#define POSTCARD_LOAD_END_Y 70
#define POSTCARD_SAVE_START_X 62
#define POSTCARD_SAVE_START_Y 71
#define POSTCARD_SAVE_END_X 156
#define POSTCARD_SAVE_END_Y 110
#define POSTCARD_EXIT_START_X 157
#define POSTCARD_EXIT_START_Y 40
#define POSTCARD_EXIT_END_X 235
#define POSTCARD_EXIT_END_Y 71
#define POSTCARD_CONTINUE_CLICK_X 180
#define POSTCARD_CONTINUE_CLICK_Y 80
#define POSTCARD_CLICK_NONE 0
#define POSTCARD_CLICK_SAVE 1
#define POSTCARD_CLICK_LOAD 2
#define POSTCARD_CLICK_EXIT 3



/**
 * action ids
 */
#define ACTION_WALK 1
#define ACTION_LOOK 2
#define ACTION_PICK 3
#define ACTION_USE 4
#define ACTION_TALK 5
#define ACTION_CONSUME 6
#define ACTION_GIVE 7
#define ACTION_MOVE 8

#define ACTION_REMOVE 1001
#define ACTION_WEAR 1002
#define ACTION_OPEN 1003
#define ACTION_CLOSE 1004

#define ACTION_AREA_RECT Common::Rect(0, 146, 74, 200)
#define ACTION_AREA_RECT_2 Common::Rect(246, 146, 320, 200)
#define INVENTORY_AREA_RECT Common::Rect(175, 146, 247, 200)

#endif


// FOTAQ
#if CURRENT_GAME_TYPE == GAME_TYPE_FOTAQ

#define MAINTAIN_ASPECT_RATIO

#define ORG_ASPECT_RATIO 1.33

#define MIN_ASPECT_RATIO 1.33
#define MAX_ASPECT_RATIO 1.78

#define GAME_SCREEN_WIDTH 320
#define GAME_SCREEN_HEIGHT 200
#define GAME_SCREEN_HEIGHT_ORIGINAL 200

#define ACTION_ALPHA 1.0

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 350

#define MIN_CLICK_DELAY_AFTER_SKIP 750

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 7
#define RENDER_MEASURE_THRESHOLD 100
#define RENDER_MEASURE_MAX_TEST_TIME 3000

// Black text panel
#define BLACK_PANEL_START_Y 150
#define BLACK_PANEL_END_Y 160
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)

#define TOUCH_INDICATOR_W 0.035
#define TOUCH_INDICATOR_BACK_W 0.13

#define CLASSIC_CURSOR_W 0.03

#define TOUCH_INDICATOR_MIN_SCALE_W 0.04
#define TOUCH_INDICATOR_MAX_SCALE_W 0.05
#define TOUCH_INDICATOR_SCALE_DURATION 750

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 0


// Inventory panel
#define INVENTORY_SCROLL_ARROW_START_X 301
#define INVENTORY_SCROLL_ARROW_END_X 315
#define INVENTORY_FLING_MIN_X 170
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_FLING_MAX_X 320
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_UP_ARROW_X 315
#define INVENTORY_UP_ARROW_Y 160
#define INVENTORY_DOWN_ARROW_X 315
#define INVENTORY_DOWN_ARROW_Y 190

// Chat assitance
#define ARROW_W 0.1
#define ARROW_H 0.14
#define UP_ARROW_X (1 - ARROW_W - 0.01)
#define UP_ARROW_Y 0.47
#define DOWN_ARROW_X (1 - ARROW_W - 0.01)
#define DOWN_ARROW_Y (UP_ARROW_Y + ARROW_H + 0.01)
#define CHAT_BUTTON_W (ARROW_W * 1.6)
#define CHAT_BUTTON_H (ARROW_H * 2 + 0.01)
#define CHAT_BUTTON_X (UP_ARROW_X - CHAT_BUTTON_W - 0.01)
#define CHAT_BUTTON_Y UP_ARROW_Y
#define CHAT_HIT_AREAS_START_Y 136

// Postcard
#define POSTCARD_WINDOW_CHECK_Y 105
#define POSTCARD_LOAD_START_X 62
#define POSTCARD_LOAD_START_Y 40
#define POSTCARD_LOAD_END_X 156
#define POSTCARD_LOAD_END_Y 70
#define POSTCARD_SAVE_START_X 62
#define POSTCARD_SAVE_START_Y 71
#define POSTCARD_SAVE_END_X 156
#define POSTCARD_SAVE_END_Y 110
#define POSTCARD_EXIT_START_X 157
#define POSTCARD_EXIT_START_Y 40
#define POSTCARD_EXIT_END_X 235
#define POSTCARD_EXIT_END_Y 71
#define POSTCARD_CONTINUE_CLICK_X 180
#define POSTCARD_CONTINUE_CLICK_Y 80
#define POSTCARD_CLICK_NONE 0
#define POSTCARD_CLICK_SAVE 1
#define POSTCARD_CLICK_LOAD 2
#define POSTCARD_CLICK_EXIT 3



/**
 * action ids
 */
#define ACTION_OPEN 1
#define ACTION_CLOSE 2
#define ACTION_MOVE 3
#define ACTION_GIVE 5
#define ACTION_USE 6
#define ACTION_PICK 7
#define ACTION_TALK 8
#define ACTION_LOOK 9
#define ACTION_WALK 10


#define ACTION_CONSUME 1001
#define ACTION_REMOVE 1002
#define ACTION_WEAR 1003


#define ACTION_AREA_RECT Common::Rect(0, 164, 160, 200)
#define ACTION_AREA_RECT_2 Common::Rect(0, 0, 0, 0)
#define INVENTORY_AREA_RECT Common::Rect(181, 164, 320, 200)


#endif


// ******** Simon 1 ********
#if CURRENT_GAME_TYPE == GAME_TYPE_SIMON1

#define MAINTAIN_ASPECT_RATIO

#define ORG_ASPECT_RATIO 1.33

#define MIN_ASPECT_RATIO 1.33
#define MAX_ASPECT_RATIO 1.78

#define GAME_SCREEN_WIDTH 320
#define GAME_SCREEN_HEIGHT 200
#define GAME_SCREEN_HEIGHT_ORIGINAL 200

#define ACTION_ALPHA 1.0

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 750

#define MIN_CLICK_DELAY_AFTER_SKIP 750

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 7
#define RENDER_MEASURE_THRESHOLD 100
#define RENDER_MEASURE_MAX_TEST_TIME 3000

// Black text panel
#define BLACK_PANEL_START_Y 134
#define BLACK_PANEL_END_Y 144
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)

#define TOUCH_INDICATOR_W 0.035
#define TOUCH_INDICATOR_BACK_W 0.13

#define CLASSIC_CURSOR_W 0.03

#ifdef WIN32
#define TOUCH_INDICATOR_MIN_SCALE_W 0.0325
#else
#define TOUCH_INDICATOR_MIN_SCALE_W 0.04
#endif

#ifdef WIN32
#define TOUCH_INDICATOR_MAX_SCALE_W 0.0425
#else
#define TOUCH_INDICATOR_MAX_SCALE_W 0.05
#endif

#define TOUCH_INDICATOR_SCALE_DURATION 750

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 0


// Inventory panel
#define INVENTORY_SCROLL_ARROW_START_X 301
#define INVENTORY_SCROLL_ARROW_END_X 315
#define INVENTORY_FLING_MIN_X 170
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_FLING_MAX_X 320
#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_UP_ARROW_X 315
#define INVENTORY_UP_ARROW_Y 160
#define INVENTORY_DOWN_ARROW_X 315
#define INVENTORY_DOWN_ARROW_Y 190



// Chat assitance
#define ARROW_W 0.1
#define ARROW_H 0.14
#define UP_ARROW_X (1 - ARROW_W - 0.01)
#define UP_ARROW_Y 0.37
#define DOWN_ARROW_X (1 - ARROW_W - 0.01)
#define DOWN_ARROW_Y (UP_ARROW_Y + ARROW_H + 0.01)
#define CHAT_BUTTON_W (ARROW_W * 1.6)
#define CHAT_BUTTON_H (ARROW_H * 2 + 0.01)
#define CHAT_BUTTON_X (UP_ARROW_X - CHAT_BUTTON_W - 0.01)
#define CHAT_BUTTON_Y UP_ARROW_Y
#define CHAT_HIT_AREAS_START_Y 136


// Postcard
#define POSTCARD_WINDOW_CHECK_Y 105
#define POSTCARD_LOAD_START_X 62
#define POSTCARD_LOAD_START_Y 40
#define POSTCARD_LOAD_END_X 156
#define POSTCARD_LOAD_END_Y 70
#define POSTCARD_SAVE_START_X 62
#define POSTCARD_SAVE_START_Y 71
#define POSTCARD_SAVE_END_X 156
#define POSTCARD_SAVE_END_Y 110
#define POSTCARD_EXIT_START_X 157
#define POSTCARD_EXIT_START_Y 40
#define POSTCARD_EXIT_END_X 235
#define POSTCARD_EXIT_END_Y 71
#define POSTCARD_CONTINUE_CLICK_X 180
#define POSTCARD_CONTINUE_CLICK_Y 80
#define POSTCARD_CLICK_NONE 0
#define POSTCARD_CLICK_SAVE 1
#define POSTCARD_CLICK_LOAD 2
#define POSTCARD_CLICK_EXIT 3

// Workaround for dragon cave
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_MIN_X 275
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_MIN_Y 0
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_MAX_X 319
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_MAX_Y 35
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_TARGET_X 298
#define OUTSIDE_DRAGON_CAVE_WORKAROUND_TARGET_Y 10



/**
 * action ids
 */
#define ACTION_WALK 101
#define ACTION_LOOK 102
#define ACTION_OPEN 103
#define ACTION_MOVE 104
#define ACTION_CONSUME 105
#define ACTION_PICK 106
#define ACTION_CLOSE 107
#define ACTION_USE 108
#define ACTION_TALK 109
#define ACTION_REMOVE 110
#define ACTION_WEAR 111
#define ACTION_GIVE 112

#define ACTION_AREA_RECT Common::Rect(0, 144, 172, 200)
#define ACTION_AREA_RECT_2 Common::Rect(0, 144, 172, 200)
#define INVENTORY_AREA_RECT Common::Rect(173, 144, 320, 200)

#endif

// ******** Simon 2 ********
#if CURRENT_GAME_TYPE == GAME_TYPE_SIMON2

#define MAINTAIN_ASPECT_RATIO

#define ORG_ASPECT_RATIO 1.33

#define MIN_ASPECT_RATIO 1.33
#define MAX_ASPECT_RATIO 1.78

#define GAME_SCREEN_WIDTH 320
#define GAME_SCREEN_HEIGHT 200
#define GAME_SCREEN_HEIGHT_ORIGINAL 200

#define CLASSIC_CURSOR_W 0.03

#define TOUCH_INDICATOR_W 0.035
#define TOUCH_INDICATOR_BACK_W 0.13

#define ACTION_ALPHA 1.0

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 750

#define MIN_CLICK_DELAY_AFTER_SKIP 750

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 7
#define RENDER_MEASURE_THRESHOLD 100
#define RENDER_MEASURE_MAX_TEST_TIME 3000

#define TOUCH_INDICATOR_MIN_SCALE_W 0.04
#define TOUCH_INDICATOR_MAX_SCALE_W 0.05
#define TOUCH_INDICATOR_SCALE_DURATION 750

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 0

// Black text panel
#define BLACK_PANEL_START_Y 134
#define BLACK_PANEL_END_Y 144
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)

// Inventory panel
#define INVENTORY_SCROLL_ARROW_START_X 301
#define INVENTORY_SCROLL_ARROW_END_X 315
#define INVENTORY_FLING_MIN_X 80
#define INVENTORY_FLING_MAX_X 240

#define INVENTORY_FLING_MIN_Y 110
#define INVENTORY_UP_ARROW_X 85
#define INVENTORY_UP_ARROW_Y 170
#define INVENTORY_DOWN_ARROW_X 230
#define INVENTORY_DOWN_ARROW_Y 170

// Chat assistance
#define ARROW_W 0.1
#define ARROW_H 0.14
#define UP_ARROW_X (1 - ARROW_W - 0.01)
#define UP_ARROW_Y 0.37
#define DOWN_ARROW_X (1 - ARROW_W - 0.01)
#define DOWN_ARROW_Y (UP_ARROW_Y + ARROW_H + 0.01)
#define CHAT_BUTTON_W (ARROW_W * 1.6)
#define CHAT_BUTTON_H (ARROW_H * 2 + 0.01)
#define CHAT_BUTTON_X (UP_ARROW_X - CHAT_BUTTON_W - 0.01)
#define CHAT_BUTTON_Y UP_ARROW_Y
#define CHAT_HIT_AREAS_START_Y 136

// Postcard
#define POSTCARD_WINDOW_CHECK_Y 110
#define POSTCARD_LOAD_START_X 65
#define POSTCARD_LOAD_START_Y 40
#define POSTCARD_LOAD_END_X 156
#define POSTCARD_LOAD_END_Y 70
#define POSTCARD_SAVE_START_X 65
#define POSTCARD_SAVE_START_Y 71
#define POSTCARD_SAVE_END_X 156
#define POSTCARD_SAVE_END_Y 109
#define POSTCARD_EXIT_START_X 157
#define POSTCARD_EXIT_START_Y 40
#define POSTCARD_EXIT_END_X 250
#define POSTCARD_EXIT_END_Y 73
#define POSTCARD_CONTINUE_CLICK_X 180
#define POSTCARD_CONTINUE_CLICK_Y 80
#define POSTCARD_CLICK_NONE 0
#define POSTCARD_CLICK_SAVE 1
#define POSTCARD_CLICK_LOAD 2
#define POSTCARD_CLICK_EXIT 3


/**
 * action ids
 */
#define ACTION_WALK 101
#define ACTION_LOOK 102
#define ACTION_PICK 103
#define ACTION_GIVE 104
#define ACTION_TALK 105
#define ACTION_USE 106
#define ACTION_WEAR 107
#define ACTION_MOVE 108
#define ACTION_OPEN 109

// Unused in Simon 2
#define ACTION_CONSUME 1001
#define ACTION_CLOSE 1002
#define ACTION_REMOVE 1003

#define ACTION_AREA_RECT Common::Rect(0, 146, 74, 200)
#define ACTION_AREA_RECT_2 Common::Rect(246, 146, 320, 200)
#define INVENTORY_AREA_RECT Common::Rect(175, 146, 247, 200)

#endif


// ******** The 7th Guest ********
#if CURRENT_GAME_TYPE == GAME_TYPE_T7G

#define MAINTAIN_ASPECT_RATIO

//#define ORG_ASPECT_RATIO 2.0

#define MIN_ASPECT_RATIO 1.78
#define MAX_ASPECT_RATIO 2.0

#define GAME_SCREEN_WIDTH 640
#define GAME_SCREEN_HEIGHT 320
#define GAME_SCREEN_HEIGHT_ORIGINAL 480

#define USE_PARTIAL_GAME_SCREEN

#define GAME_SCREEN_START_Y 80
#define GAME_SCREEN_END_Y 400

#define ACTION_ALPHA 0.7

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 400

#define MIN_CLICK_DELAY_AFTER_SKIP 1000

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 15
#define RENDER_MEASURE_THRESHOLD 70
#define RENDER_MEASURE_MAX_TEST_TIME 3000


#define CLASSIC_CURSOR_W 0.07

#define TOUCH_INDICATOR_W 0.045
#define TOUCH_INDICATOR_BACK_W 0.13

#define TOUCH_INDICATOR_MIN_SCALE_W 0
#define TOUCH_INDICATOR_MAX_SCALE_W 0.065
#define TOUCH_INDICATOR_SCALE_DURATION 500

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 1


//
// Irrelevant constants
//
#define BLACK_PANEL_START_Y 0
#define BLACK_PANEL_END_Y 0
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)
#define INVENTORY_SCROLL_ARROW_START_X 0
#define INVENTORY_SCROLL_ARROW_END_X 0
#define INVENTORY_FLING_MIN_X 0
#define INVENTORY_FLING_MAX_X 0
#define INVENTORY_FLING_MIN_Y 0
#define INVENTORY_UP_ARROW_X 0
#define INVENTORY_UP_ARROW_Y 0
#define INVENTORY_DOWN_ARROW_X 0
#define INVENTORY_DOWN_ARROW_Y 0
#define ARROW_W 0.0
#define ARROW_H 0.0
#define UP_ARROW_X 0.0
#define UP_ARROW_Y 0.0
#define DOWN_ARROW_X 0.0
#define DOWN_ARROW_Y 0.0
#define CHAT_BUTTON_W 0.0
#define CHAT_BUTTON_H 0.0
#define CHAT_BUTTON_X 0.0
#define CHAT_BUTTON_Y 0.0
#define CHAT_HIT_AREAS_START_Y 0
#define POSTCARD_WINDOW_CHECK_Y 0
#define POSTCARD_LOAD_START_X 0
#define POSTCARD_LOAD_START_Y 0
#define POSTCARD_LOAD_END_X 0
#define POSTCARD_LOAD_END_Y 0
#define POSTCARD_SAVE_START_X 0
#define POSTCARD_SAVE_START_Y 0
#define POSTCARD_SAVE_END_X 0
#define POSTCARD_SAVE_END_Y 0
#define POSTCARD_EXIT_START_X 0
#define POSTCARD_EXIT_START_Y 0
#define POSTCARD_EXIT_END_X 0
#define POSTCARD_EXIT_END_Y 0
#define POSTCARD_CONTINUE_CLICK_X 0
#define POSTCARD_CONTINUE_CLICK_Y 0
#define POSTCARD_CLICK_NONE 0
#define POSTCARD_CLICK_SAVE 1
#define POSTCARD_CLICK_LOAD 2
#define POSTCARD_CLICK_EXIT 3
#define ACTION_WALK 0
#define ACTION_LOOK 1
#define ACTION_PICK 2
#define ACTION_GIVE 3
#define ACTION_TALK 4
#define ACTION_USE 5
#define ACTION_WEAR 6
#define ACTION_MOVE 7
#define ACTION_OPEN 8
#define ACTION_CONSUME 9
#define ACTION_CLOSE 10
#define ACTION_REMOVE 11

#define ACTION_AREA_RECT Common::Rect(0, 0, 0, 0)
#define ACTION_AREA_RECT_2 Common::Rect(0, 0, 0, 0)
#define INVENTORY_AREA_RECT Common::Rect(175, 146, 247, 200)

#endif


// ******** Tony Tough ********
#if CURRENT_GAME_TYPE == GAME_TYPE_TONYT

#define GAME_SCREEN_WIDTH 640
#define GAME_SCREEN_HEIGHT 480
#define GAME_SCREEN_HEIGHT_ORIGINAL 480

#define ACTION_ALPHA 0.7

#define LONG_CLICK_ACTION_MIN_TOUCH_TIME 400

#define MIN_CLICK_DELAY_AFTER_SKIP 1000

// These values are VERY important!
// They take into account the number of frames shown in the game's first animation, and how much it takes overall.
#define RENDER_MEASURE_SKIPPED_FRAMES 3
#define RENDER_MEASURE_COUNT_MAX 15
#define RENDER_MEASURE_THRESHOLD 70
#define RENDER_MEASURE_MAX_TEST_TIME 3000


#define CLASSIC_CURSOR_W 0.07

#define TOUCH_INDICATOR_W 0.045
#define TOUCH_INDICATOR_BACK_W 0.13

#define TOUCH_INDICATOR_MIN_SCALE_W 0
#define TOUCH_INDICATOR_MAX_SCALE_W 0.065
#define TOUCH_INDICATOR_SCALE_DURATION 500

#define ADJUST_HOTSPOT_INDICATOR_FOR_FINGER 1


//
// Irrelevant constants
//
#define BLACK_PANEL_START_Y 0
#define BLACK_PANEL_END_Y 0
#define GAME_SCREEN_START_Y 0
#define GAME_SCREEN_END_Y 640
#define BLACK_PANEL_HEIGHT (BLACK_PANEL_END_Y - BLACK_PANEL_START_Y)
#define INVENTORY_SCROLL_ARROW_START_X 0
#define INVENTORY_SCROLL_ARROW_END_X 0
#define INVENTORY_FLING_MIN_X 0
#define INVENTORY_FLING_MAX_X 0
#define INVENTORY_FLING_MIN_Y 0
#define INVENTORY_UP_ARROW_X 0
#define INVENTORY_UP_ARROW_Y 0
#define INVENTORY_DOWN_ARROW_X 0
#define INVENTORY_DOWN_ARROW_Y 0
#define ARROW_W 0.0
#define ARROW_H 0.0
#define UP_ARROW_X 0.0
#define UP_ARROW_Y 0.0
#define DOWN_ARROW_X 0.0
#define DOWN_ARROW_Y 0.0
#define CHAT_BUTTON_W 0.0
#define CHAT_BUTTON_H 0.0
#define CHAT_BUTTON_X 0.0
#define CHAT_BUTTON_Y 0.0
#define CHAT_HIT_AREAS_START_Y 0
#define ACTION_WALK 0
#define ACTION_LOOK 1
#define ACTION_PICK 2
#define ACTION_GIVE 3
#define ACTION_TALK 4
#define ACTION_USE 5
#define ACTION_WEAR 6
#define ACTION_MOVE 7
#define ACTION_OPEN 8
#define ACTION_CONSUME 9
#define ACTION_CLOSE 10
#define ACTION_REMOVE 11

#define ACTION_AREA_RECT Common::Rect(0, 146, 74, 200)
#define ACTION_AREA_RECT Common::Rect(246, 146, 320, 200)
#define INVENTORY_AREA_RECT Common::Rect(175, 146, 247, 200)

#endif


#endif /* CONSTANTS_H_ */
